﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Chess.Test
{
    [TestClass]
    public class BoardTest
    {
        private Pawn Piece { get; set; }
        private Board Target { get; set; }

        [TestInitialize]
        public void BeforeEachTest()
        {
            Piece = new Pawn();
            Target = new Board();
        }

        [TestClass]
        public class GetPiece : BoardTest
        {
            [TestMethod]
            public void RetrievesPieceAddedToLocation()
            {
                Target.AddPiece(Piece, 1, 1);
                Assert.AreEqual(Piece, Target.GetPiece(1, 1));
            }
        }

        [TestClass]
        public class AddPiece : BoardTest
        {
            [TestMethod]
            public void DoesNotThrowExceptionWhenAddingAPieceToAnUnoccupiedSquare()
            {
                Target.AddPiece(new Pawn(), 1, 2);
            }
        }
    }
}
